Bug 1052710 - (CVE-2017-12675) VUL-1: CVE-2017-12675: GraphicsMagick, ImageMagick: Missing free for multidimensional data in coders/mat.c, leading to a memory leak
(CVE-2017-12675)
VUL-1: CVE-2017-12675: GraphicsMagick, ImageMagick: Missing free for multidim...
Status: RESOLVED FIXED
Classification: Novell Products
Product: SUSE Security Incidents
Classification: Novell Products
Component: Incidents
unspecified
Other Other
: P4 - Low : Normal
: ---
Assigned To: Security Team bot
Security Team bot
https://smash.suse.de/issue/189783/
CVSSv2:SUSE:CVE-2017-12675:5.0:(AV:N/...
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2017-08-08 08:11 UTC by Johannes Segitz
Modified: 2020-06-11 20:32 UTC (History)
1 user (show)

See Also:
Found By: Security Response Team
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments
Reproducer (202 bytes, application/octet-stream)
2017-08-08 08:11 UTC, Johannes Segitz
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Johannes Segitz 2017-08-08 08:11:58 UTC
Created attachment 735637 [details]
Reproducer

CVE-2017-12675

In ImageMagick 7.0.6-3, a missing check for multidimensional data was found in
coders/mat.c, leading to a memory leak in the function ReadImage in
MagickCore/constitute.c, which allows attackers to cause a denial of service.

valgrind identify memory_leak_in_ReadImage.mat

References:
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2017-12675
https://github.com/ImageMagick/ImageMagick/issues/616
Comment 2 Petr Gajdos 2018-01-08 08:45:31 UTC
12/ImageMagick

BEFORE

$ valgrind -q --leak-check=full identify memory_leak_in_ReadImage.mat
identify: multi-dimensional matrices are not supported `memory_leak_in_ReadImage.mat' @ error/mat.c/ReadMATImage/744.
==18066== 26,216 (16,792 direct, 9,424 indirect) bytes in 1 blocks are definitely lost in loss record 15 of 15
==18066==    at 0x4C29110: malloc (in /usr/lib64/valgrind/vgpreload_memcheck-amd64-linux.so)
==18066==    by 0x4F48E1F: AcquireImageInfo (image.c:334)
==18066==    by 0x4F4AB3D: CloneImageInfo (image.c:936)
==18066==    by 0x8418267: ???
==18066==    by 0x4EBFE1A: ReadImage (constitute.c:601)
==18066==    by 0x4FD1658: ReadStream (stream.c:974)
==18066==    by 0x4EBF960: PingImage (constitute.c:278)
==18066==    by 0x4EBFB9A: PingImages (constitute.c:373)
==18066==    by 0x535850B: IdentifyImageCommand (identify.c:322)
==18066==    by 0x5385C52: MagickCommandGenesis (mogrify.c:166)
==18066==    by 0x400891: IdentifyMain (identify.c:80)
==18066==    by 0x400891: main (identify.c:93)
==18066== 
$

AFTER

$ valgrind -q --leak-check=full identify memory_leak_in_ReadImage.mat
identify: multi-dimensional matrices are not supported `memory_leak_in_ReadImage.mat' @ error/mat.c/ReadMATImage/1044.
$
Comment 4 Petr Gajdos 2018-01-08 11:05:22 UTC
11/ImageMagick

BEFORE

$ valgrind -q --leak-check=full identify memory_leak_in_ReadImage.mat
identify: Multi-dimensional matrices are not supported `memory_leak_in_ReadImage.mat'.
==11080== 
==11080== 16,784 bytes in 1 blocks are definitely lost in loss record 2 of 2
==11080==    at 0x4C256AE: malloc (in /usr/lib64/valgrind/amd64-linux/vgpreload_memcheck.so)
==11080==    by 0x4F0AF9E: AcquireImageInfo (image.c:368)
==11080==    by 0x4F0B05D: CloneImageInfo (image.c:1223)
==11080==    by 0x9F09180: ???
==11080==    by 0x4E94D87: ReadImage (constitute.c:441)
==11080==    by 0x52D0C14: IdentifyImageCommand (identify.c:297)
==11080==    by 0x400DA7: main (identify.c:101)
$

AFTER

$ valgrind -q --leak-check=full identify memory_leak_in_ReadImage.mat
identify: Multi-dimensional matrices are not supported `memory_leak_in_ReadImage.mat'.
$
Comment 6 Petr Gajdos 2018-01-08 14:26:15 UTC
HG/GraphicsMagick

$ valgrind -q --leak-check=full gm identify memory_leak_in_ReadImage.mat
gm identify: Multi-dimensional matrices are not supported (memory_leak_in_ReadImage.mat).
gm identify: Request did not return an image.
$

42.x/GraphicsMagick

$ valgrind -q --leak-check=full gm identify memory_leak_in_ReadImage.mat
gm identify: Multi-dimensional matrices are not supported (memory_leak_in_ReadImage.mat).
gm identify: Request did not return an image.
$

11/GraphicsMagick

$ valgrind -q --leak-check=full gm identify memory_leak_in_ReadImage.mat
gm identify: Multi-dimensional matrices are not supported (memory_leak_in_ReadImage.mat).
$

Does not reproduce.

11/GraphicsMagick: no image2 or clone_info variables
42.x/GraphicsMagick: affected, will use ThrowImg2MATReaderException() on that place
HG/GraphicsMagick: ThrowMATReaderException() and ThrowImg2MATReaderException()
Comment 7 Petr Gajdos 2018-01-08 14:26:44 UTC
Will submit for 12/ImageMagick, 11/ImageMagick and 42.x/GraphicsMagick.
Comment 8 Petr Gajdos 2018-01-08 15:26:53 UTC
I believe all fixed.
Comment 9 Swamp Workflow Management 2018-01-08 15:50:24 UTC
This is an autogenerated message for OBS integration:
This bug (1052710) was mentioned in
https://build.opensuse.org/request/show/562562 42.3 / GraphicsMagick
https://build.opensuse.org/request/show/562563 42.2 / GraphicsMagick
Comment 10 Swamp Workflow Management 2018-01-09 13:10:24 UTC
This is an autogenerated message for OBS integration:
This bug (1052710) was mentioned in
https://build.opensuse.org/request/show/562871 42.3 / GraphicsMagick
https://build.opensuse.org/request/show/562872 42.2 / GraphicsMagick
Comment 12 Swamp Workflow Management 2018-01-15 14:08:43 UTC
openSUSE-SU-2018:0087-1: An update that solves 13 vulnerabilities and has one errata is now available.

Category: security (moderate)
Bug References: 1047044,1049373,1050129,1051412,1052468,1052710,1052720,1052731,1055065,1055434,1058640,1067177,1074123,1074975
CVE References: CVE-2017-10800,CVE-2017-11449,CVE-2017-11532,CVE-2017-12564,CVE-2017-12670,CVE-2017-12672,CVE-2017-12675,CVE-2017-13060,CVE-2017-13648,CVE-2017-14326,CVE-2017-16547,CVE-2017-17881,CVE-2017-18022
Sources used:
openSUSE Leap 42.3 (src):    GraphicsMagick-1.3.25-57.1
openSUSE Leap 42.2 (src):    GraphicsMagick-1.3.25-11.60.1
Comment 13 Swamp Workflow Management 2018-01-18 14:08:44 UTC
SUSE-SU-2018:0130-1: An update that fixes 21 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1047044,1047898,1050120,1050606,1051446,1052468,1052550,1052710,1052720,1052731,1052732,1055065,1055323,1055434,1055855,1058640,1059751,1074123,1074969,1074973,1074975
CVE References: CVE-2017-10800,CVE-2017-11141,CVE-2017-11529,CVE-2017-11644,CVE-2017-11724,CVE-2017-12434,CVE-2017-12564,CVE-2017-12667,CVE-2017-12670,CVE-2017-12672,CVE-2017-12675,CVE-2017-13060,CVE-2017-13146,CVE-2017-13648,CVE-2017-13658,CVE-2017-14326,CVE-2017-14533,CVE-2017-17881,CVE-2017-18022,CVE-2018-5246,CVE-2018-5247
Sources used:
SUSE Linux Enterprise Workstation Extension 12-SP3 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Workstation Extension 12-SP2 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Software Development Kit 12-SP3 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Software Development Kit 12-SP2 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Server for Raspberry Pi 12-SP2 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Server 12-SP3 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Server 12-SP2 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Desktop 12-SP3 (src):    ImageMagick-6.8.8.1-71.26.1
SUSE Linux Enterprise Desktop 12-SP2 (src):    ImageMagick-6.8.8.1-71.26.1
Comment 14 Swamp Workflow Management 2018-01-18 14:13:32 UTC
SUSE-SU-2018:0132-1: An update that fixes 31 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042948,1047044,1047898,1049373,1050120,1050606,1051412,1051446,1052252,1052468,1052550,1052710,1052720,1052731,1052732,1052771,1055065,1055323,1055434,1055855,1058082,1058640,1059751,1072902,1074122,1074123,1074425,1074610,1074969,1074973,1074975
CVE References: CVE-2017-1000445,CVE-2017-1000476,CVE-2017-10800,CVE-2017-11141,CVE-2017-11449,CVE-2017-11529,CVE-2017-11644,CVE-2017-11724,CVE-2017-11751,CVE-2017-12430,CVE-2017-12434,CVE-2017-12564,CVE-2017-12642,CVE-2017-12667,CVE-2017-12670,CVE-2017-12672,CVE-2017-12675,CVE-2017-13060,CVE-2017-13146,CVE-2017-13648,CVE-2017-13658,CVE-2017-14249,CVE-2017-14326,CVE-2017-14533,CVE-2017-17680,CVE-2017-17881,CVE-2017-17882,CVE-2017-18022,CVE-2017-9409,CVE-2018-5246,CVE-2018-5247
Sources used:
SUSE Linux Enterprise Software Development Kit 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.22.1
SUSE Linux Enterprise Server 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.22.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.22.1
Comment 15 Swamp Workflow Management 2018-01-20 17:13:02 UTC
openSUSE-SU-2018:0155-1: An update that fixes 21 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1047044,1047898,1050120,1050606,1051446,1052468,1052550,1052710,1052720,1052731,1052732,1055065,1055323,1055434,1055855,1058640,1059751,1074123,1074969,1074973,1074975
CVE References: CVE-2017-10800,CVE-2017-11141,CVE-2017-11529,CVE-2017-11644,CVE-2017-11724,CVE-2017-12434,CVE-2017-12564,CVE-2017-12667,CVE-2017-12670,CVE-2017-12672,CVE-2017-12675,CVE-2017-13060,CVE-2017-13146,CVE-2017-13648,CVE-2017-13658,CVE-2017-14326,CVE-2017-14533,CVE-2017-17881,CVE-2017-18022,CVE-2018-5246,CVE-2018-5247
Sources used:
openSUSE Leap 42.3 (src):    ImageMagick-6.8.8.1-49.1
openSUSE Leap 42.2 (src):    ImageMagick-6.8.8.1-30.21.1
Comment 16 Marcus Meissner 2018-02-09 15:33:31 UTC
released